// Global variables
var gImagePath = "Resources/Images/";
var gBackgroudImage = "Window/theBackground.png";
var gNeedleImage = "needle.png";

var gReceivedAverage = new Array();
var gSentAverage = new Array();
var gLastReceivedAverage = 0;
var gLastSentAverage = 0;
var gArraySize = 0;
var gArrayIndex = 0;
var gLastReceivedBytes = 0;
var gLastSentBytes = 0;
var gInterval = 0;
var gMaxReceivedValue = 0;
var gMaxSentValue = 0;


var gSpanAngle = 120;
var gSpanMin = -(gSpanAngle/2);
var gSpanMax = gSpanAngle/2;

// Global Graphics
var gTheBackground = new Image();
var gTheNeedleReceived = new Image();
var gTheNeedleSent = new Image();
//var gTheNeedleTmp = new Image();

// Global Texts
var gReceivedValueText = new Text();
var gSentValueText = new Text();
var gReceivedMinText = new Text();
var gReceivedMidText = new Text();
var gReceivedMaxText = new Text();
var gSentMinText = new Text();
var gSentMidText = new Text();
var gSentMaxText = new Text();

var gMeanTextSize = 10;
var gMeanTextColor = "#FFFF00";
var gMeanTextStyle = "condensed";
var gMeanTextAlignment = "center";
var gMeanTextFont = "Verdana, Arial";

var gMinTextSize = 6;
var gMinTextColor = "#DB7F9D";
var gMinTextStyle = "condensed, bold";
var gMinTextAlignment = "center";
var gMinTextFont = "Verdana, Arial";

// Start Widget
doLoadWidget();


function doLoadWidget()
{
  print("doLoadWidget()");
  doInitWidgetValues();
  doInitImages();
  doInitTexts();

  doRefresh();
}

function doInitWidgetValues()
{
  //Init array size
  gArraySize = parseInt(preferences.span.value);
  gInterval = parseInt(preferences.interval.value);
  gMaxReceivedValue = Math.round(parseInt(preferences.maxReveivedValue.value)/10)*10;
  gMaxSentValue = parseInt(preferences.maxSentValue.value);
  doInitTexts();
  
  //Init Array
  for(i=0; i<gArraySize; i++)
  {
    gReceivedAverage[i] = 0;
  }
  
  //Starts the update timer
  print("start timer");
  updateTimer = new Timer();
  updateTimer.interval = gInterval;
  updateTimer.ticking = 1;
  updateTimer.onTimerFired = "doRefresh();";
}

function doInitImages()
{
  print("doInitImages()");
  gTheBackground.src=gImagePath+gBackgroudImage;
  gTheBackground.width = 150;
  gTheBackground.height = 100;
  gTheBackground.hOffset = 0;
  gTheBackground.vOffset = 0;
  gTheBackground.opacity = 200;  
  
  gTheNeedleReceived.src=gImagePath+gNeedleImage;
  gTheNeedleReceived.width = 14;
  gTheNeedleReceived.height = 34;
  gTheNeedleReceived.vOffset = 48;
  gTheNeedleReceived.opacity = 255;
  gTheNeedleReceived.hRegistrationPoint = 7;
  gTheNeedleReceived.vRegistrationPoint = 28;
  gTheNeedleReceived.rotation = gSpanMin;
  gTheNeedleReceived.hOffset = 41;
  
  
  gTheNeedleSent.src=gImagePath+gNeedleImage;
  gTheNeedleSent.width = gTheNeedleReceived.width;
  gTheNeedleSent.height = gTheNeedleReceived.height;
  gTheNeedleSent.vOffset = gTheNeedleReceived.vOffset;
  gTheNeedleSent.opacity = gTheNeedleReceived.opacity;
  gTheNeedleSent.hRegistrationPoint = gTheNeedleReceived.hRegistrationPoint;
  gTheNeedleSent.vRegistrationPoint = gTheNeedleReceived.vRegistrationPoint;
  gTheNeedleSent.rotation = gSpanMin;
  gTheNeedleSent.hOffset = 110;
  
} // doInitImages()

function doInitTexts()
{
  print("doInitTexts()");
  gReceivedValueText.data = "10KB/s";//Bbeautify_bytes(gLastReceivedAverage);
  gReceivedValueText.alignment = gMeanTextAlignment;
  gReceivedValueText.hOffset = 41;
  gReceivedValueText.vOffset = 65;
  gReceivedValueText.color = gMeanTextColor;
  gReceivedValueText.style = gMeanTextStyle;
  gReceivedValueText.size = gMeanTextSize;
  gReceivedValueText.font = gMeanTextFont;
  
  gSentValueText.data = "100B/s";//Bbeautify_bytes(gLastSentAverage);
  gSentValueText.alignment = gMeanTextAlignment;
  gSentValueText.hOffset = 110;
  gSentValueText.vOffset = gReceivedValueText.vOffset;
  gSentValueText.color = gMeanTextColor;
  gSentValueText.style = gMeanTextStyle;
  gSentValueText.size = gMeanTextSize;
  gSentValueText.font = gMeanTextFont;
  
  gReceivedMinText.data = "0";
  gReceivedMinText.alignment = "right";
  gReceivedMinText.color = gMinTextColor;
  gReceivedMinText.style = gMinTextStyle;
  gReceivedMinText.size = gMinTextSize;
  gReceivedMinText.font = gMinTextFont;
  gReceivedMinText.hOffset = 16;
  gReceivedMinText.vOffset = 32;
  
  gReceivedMaxText.data = Bbeautify_bytes_max(gMaxReceivedValue);
  gReceivedMaxText.alignment = "left";
  gReceivedMaxText.color = gMinTextColor;
  gReceivedMaxText.style = gMinTextStyle;
  gReceivedMaxText.size = gMinTextSize;
  gReceivedMaxText.font = gMinTextFont;
  gReceivedMaxText.hOffset = 63;
  gReceivedMaxText.vOffset = 32;
  
} // doInitTexts()

function doRefresh()
{
  //print("doRefresh()");
  var result = new Array();
  output=runCommand("netstat -e");
  result = doParseNetstatOutput(output);
  
  if(gLastReceivedBytes != 0)
  {
    var tmp = Math.round((result[0] - gLastReceivedBytes)/gInterval);
    gReceivedAverage[gArrayIndex] = tmp;
  }
  gLastReceivedBytes = result[0];
  
  if(gArrayIndex+1 < gArraySize)
  {
    gArrayIndex++;
  }
  else
  {
    gArrayIndex = 0;
  }
  
  //print("gArrayIndex=" + gArrayIndex);
  //print("gArraySize=" + gArraySize);
  //print("gLastReceivedBytes=" + gLastReceivedBytes);
  var gCurrentSum = 0;
  for(i=0; i<gArraySize; i++)
  {
    //print("gReceivedAverage[" + i + "]: "+ gReceivedAverage[i] + " B/s");
    gCurrentSum += gReceivedAverage[i];
  }
  var currentReceivedAverage = Math.round(gCurrentSum/gArraySize);
  //print("gCurrentSum = " + gCurrentSum + " B/s");
  //print("currentReceivedAverage = " + currentReceivedAverage + " B/s");
  
  gLastReceivedAverage = currentReceivedAverage;
  
  var receivedAngle = doCalculateReceiveAngle(gLastReceivedAverage);
  doRotateNeedles(receivedAngle);
  gReceivedValueText.data = Bbeautify_bytes(gLastReceivedAverage);
} // doRefresh()

function doCalculateReceiveAngle(xValue)
{
  var retVal = gSpanMin + Math.round(xValue / gMaxReceivedValue * gSpanAngle);
  if(retVal > gSpanMax)
  {
    retVal = gSpanMax;
  }
  print("Angle value = " + retVal + "");
  return retVal;
}

function doParseNetstatOutput(output)
{
  //print("doParseNetstatOutput()");
  var lines=output.split("\n");
  var tmpRegExp = /([\d]+)\s*([\d]+)/;
  var tmpString = tmpRegExp.exec(lines[4]);
  var result = new Array();
  result[0] = tmpString[1];
  result[1] = tmpString[2];
  return result;
}

function Bbeautify_bytes ( bytes )
{
	types=new Array( 'B/s', 'KB/s', 'MB/s', 'GB/s', 'TB/s', 'PB/s' );
	count=0;
	while ( bytes > 1024 ) {
		bytes=parseFloat(bytes / 1024);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + " " + types[count];
	return output;
}


function Bbeautify_bytes_max ( bytes )
{
	types=new Array( 'B', 'K', 'M', 'G', 'T', 'P' );
	count=0;
	while ( bytes > 1024 ) {
		bytes=parseFloat(bytes / 1024);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + types[count];
	return output;
}

function bbeautify_bytes ( bytes )
{
	bytes = bytes * 8;
	types=new Array( 'b/s', 'Kb/s', 'Mb/s', 'Gb/s', 'Tb/s', 'Pb/s' );
	count=0;
	while ( bytes > 1024 ) {
		bytes=parseFloat(bytes / 1024);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + " " + types[count];
	return output;
}

function doRotateNeedles()
{
  var receiveNeedle = new RotateAnimation(gTheNeedleReceived, doCalculateReceiveAngle(gLastReceivedAverage), gInterval*1000, animator.kEaseOut, ReceiveDone);
  animator.start(receiveNeedle);
}
function ReceiveDone()
{
  print("Rotation done!");
}